/*
 * \author João V. Gomes
 *
 *  packetprocessor.h
 *
 *  Created on: Apr 13, 2011
 *
 * \brief TODO
 * TODO
 */

#include <iostream>
#include <sstream>
#include <string>
#include <vector>
#include <typeinfo>

#include <statisticalanalyzer.h>
#include <packetprocessor.h>
#include <pcapwrap.h>
#include <Folder.h>

using namespace std;

void testA()
{
	EntropyContainer<int> Econt(10);

    cout << "Max for window of " << 10 << " packets: " << log(10) << "\n";

    Econt.AddValue(175);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(175);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(160);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(200);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(200);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(200);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(165);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(125);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(100);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(100);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";
    Econt.AddValue(150);
    cout << "Entropy: " << Econt.EntropyVal() << "\n";

    cout << "\nTotal analyzed items: " << Econt.TotalAnalyzedItems() << "\n";

    Econt.Clear();

    cout << "\nAQUI\n";

//    Econt.~EntropyContainer();

    cout << "\nALI\n";

}

void testB()
{
//    char sResp[100];
//    cout << "Hello world!" << endl;
//    cout << "E que me dizes? Responde aqui: ";
//    cin >> sResp;
//    cout << "Então dizes isto: " << sResp << "\n";


    int i=0;
    int op;

    try
    {

//    /* Retrieve the device list from the local machine */
//    if (pcap_findalldevs(&alldevs, errbuf) == -1)
//    {
//        fprintf(stderr,"Error in pcap_findalldevs_ex: %s\n", errbuf);
//        return(1);
//    }
//
//    /* Print the list */
//    for(d= alldevs; d != NULL; d= d->next)
//    {
//        printf("%d. %s", ++i, d->name);
//        if (d->description)
//            printf(" (%s)\n", d->description);
//        else
//            printf(" (No description available)\n");
//    }
//
////    string opt();
//    cout << "Option: ";
//    cin >> op;
//    cout << "Escolheu a " << op << "\n";
////    op = (int) opt;
//
//    i = 0;
//    d = alldevs;
//    while (i < op-1 && d != NULL)
//    {
//        d = d->next;
//        i++;
//    }
//
//    char *dev = d -> name;

    // TODO: catch an exception
    //PacketSource psSrc(dev, 100, 1000);

    PacketSource psSrc;

    vector<Device> DevL = psSrc.GetDeviceList();
    vector<Device>::iterator it;

    for (it = DevL.begin(); it < DevL.end(); it++)
    {
        i++;
        cout << i << ". " << it->Name() << " " << it->Description() << "\n";
    }

    Device * P = &(*(DevL.begin()));

    DevL.clear();

   // cout << "\n--- AQUI --- " << P->Name() << " " << P->Description() << "\n\n";

    i = 0;
    for (it = DevL.begin(); it < DevL.end(); it++)
    {
        i++;
        cout << i << ". " << it->Name() << " " << it->Description() << "\n";
    }


    psSrc.CloseSource();


//    psSrc.OpenOfflineSource("/home/joao/SandBox/sample_29042010_1.pcap");
    psSrc.OpenOfflineSource("/media/38b7bcfa-02d8-45b7-8fd1-5b588faf09a8/joao/SandBox/test_traces/home-05062010_1.pcap");
    PacketProcessor PProc(&psSrc);

    //pcap_freealldevs(alldevs);

    Packet *Pkt1, *Pkt2;

    int prot = 0, prot2 = 0;
    long tssec = 0, tsmsec = 0;

//    while ((tssec != 1272549522) || (tsmsec != 307563))
//    {
    while (prot != PKT_PTC_TCP)
    {
//        delete Pkt1;
    cout << " --- " << typeid(Pkt2).name() << " --- \n";

        Pkt1 = psSrc.NextPacket();
//        Pkt2 = psSrc.NextPacket();
        Pkt2 = Pkt1;
        prot = Pkt1->Protocol();
        prot2 = Pkt1->Protocol();
        tssec = Pkt1->TSseconds();
        tsmsec = Pkt1->TSmicrosec();
    }

    cout << " --- " << typeid(*Pkt1).name() << " --- \n";


//    if (Pkt1->Protocol() == PKT_PTC_TCP)
//    {
//        TCPPacket * Pkt = (TCPPacket*) &Pkt1;
        TCPPacket * Pkt = dynamic_cast<TCPPacket *>(Pkt1);
        cout << "\n" << Pkt->TSseconds() << "." << Pkt->TSmicrosec() << "\n";
        cout << "Protocol: " << Pkt->Protocol() << "\n";
        cout << *(Pkt->SrcMACaddr()) << " -> " << *(Pkt->DstMACaddr()) << "\n";
        cout << *(Pkt->SrcIPaddr()) << ":" << Pkt->SrcPort() << "->" << *(Pkt->DstIPaddr()) << ":" << Pkt->DstPort() << "\n";
        cout << "Prot: " << prot << "\n";
        cout << "URG Flag: " << Pkt->Urg() << "\n";
        cout << "ACK Flag: " << Pkt->Ack() << "\n";
        cout << "PSH Flag: " << Pkt->Psh() << "\n";
        cout << "RST Flag: " << Pkt->Rst() << "\n";
        cout << "Length: " << Pkt->Len() << " | Captured Length: " << Pkt->CapLen() << "\n";
        cout << "IP Total Length: " << Pkt->IPlen() << "\n";


        TCPPacket * Pktt = dynamic_cast<TCPPacket*>(Pkt2);
        cout << "\n" << Pktt->TSseconds() << "." << Pktt->TSmicrosec() << "\n";
        cout << "Protocol: " << Pktt->Protocol() << "\n";
        cout << *(Pktt->SrcMACaddr()) << " -> " << *(Pktt->DstMACaddr()) << "\n";
        cout << *(Pktt->SrcIPaddr()) << ":" << Pktt->SrcPort() << "->" << *(Pktt->DstIPaddr()) << ":" << Pktt->DstPort() << "\n";
        cout << "Prot: " << prot2 << "\n";
        cout << "URG Flag: " << Pktt->Urg() << "\n";
        cout << "ACK Flag: " << Pktt->Ack() << "\n";
        cout << "PSH Flag: " << Pktt->Psh() << "\n";
        cout << "RST Flag: " << Pktt->Rst() << "\n";


//    if (Pkt1->Protocol() == PKT_PTC_IP)
//    {
//        IPPacket Pkt = (*((IPPacket*) Pkt1));
//        cout << ((string)(Pkt.SourceMACaddr())) << " -> " << ((string)(Pkt.DestinationMACaddr())) << "\n";
////        cout << " -> " << ((string)(Pkt.DestinationMACaddr())) << "\n";
//        cout << ((string)(Pkt.SourceIPaddr())) << " -> " << ((string)(Pkt.DestinationIPaddr())) << "\n";
//    }

    psSrc.CloseSource();

//    delete (Pkt1);
//    delete psSrc;

    }
    catch (Src_Already_Open e)
    {
        cout << "This Object PacketSource already has an open source. Please close it first.\n";
    }
    catch (Dev_Open_Offline_Fail e1)
    {
        cout << "Failed to open the file: " << e1.what() << "\n";
    }
    catch (Dev_Open_Live_Fail e2)
    {
        cout << "Failed to open the device: " << e2.what() << "\n";
    }
    catch (Dev_Open_Live_Warning e3)
    {
        cout << "Warning: " << e3.what() << "\n";
    }
    catch (Timeout_Expired e4)
    {
        cout << "Timeout: " << e4.what() << "\n";
    }
    catch (No_More_Packets e5)
    {
        cout << "No more packets: " << e5.what() << "\n";
    }
    catch (Packet_Reading_Error e6)
    {
        cout << "Failed: " << e6.what() << "\n";
    }
    catch (Src_Not_Open e7)
    {
        cout << "The Packet Source is not open yet. Please provide an open source.\n";
    }
    catch (PSrc_Not_Open e8)
    {
        cout << "Packet Source failed: " << e8.what() << "\n";
    }
}

int main()
{
//    testA();
//    testB();
    return 0;
}


