/*
 * \author João V. Gomes
 *
 *  ppexception.h
 *
 *  Created on: Dec 30, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef PPEXCEPTION_H_
#define PPEXCEPTION_H_

#include <stdexcept>
#include <string>

///
/// Generic PacketProcessor Exception.
///	Derives from std::runtime_error.
///
class PPException : public std::runtime_error
{
	public:

		PPException(std::string const& err_msg)
		:	std::runtime_error(err_msg)
		{ }

};

class PSrc_Not_Open : public PPException
{
    public:

        PSrc_Not_Open()
        :   PPException("The Packet Source is not open. Please provide an open source.")
        { }
};

#endif /* PPEXCEPTION_H_ */
