/*
 * \author João V. Gomes
 *
 *  hostclassifier.h
 *
 *  Created on: Jun 24, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef HOSTCLASSIFIER_H_
#define HOSTCLASSIFIER_H_

#include "hostanalyzer.h"
#include <thresholdsset.h>

template<class V>
class HostClassifier: public HostAnalyzer<V> {
public:
	HostClassifier();
	HostClassifier(const int &WinSize, const std::string &LogsPath, ThresholdsSet * TSet);
	virtual ~HostClassifier();

private:
	void init(const int &WinSize, const std::string &LogsPath, ThresholdsSet * TSet);
	void WriteEntropy(const std::string &HostIP, const long &TSsec, const long &TSusec, const V &Value, const double &EntropyVal) const;

	ThresholdsSet * Thresholds;
};

#endif /* HOSTCLASSIFIER_H_ */
