/*
 * \author João V. Gomes
 *
 *  meanvariancedump.cpp
 *
 *  Created on: Nov 20, 2010
 *
 * \brief TODO
 * TODO
 */

#include "meanvariancedump.h"
#include <iostream>

MeanVarianceDump::MeanVarianceDump() {
	this->init();

}

MeanVarianceDump::~MeanVarianceDump() {
	this->dispose();
}

void MeanVarianceDump::init() {
	this->CurrentMeanX = 0;
	this->CurrentMeanX2 = 0;
	this->Total = 0;
}

void MeanVarianceDump::dispose() {

}

void MeanVarianceDump::Clear() {
	this->CurrentMeanX = 0;
	this->CurrentMeanX2 = 0;
	this->Total = 0;

	this->dispose();
}

const double MeanVarianceDump::Variance() const {
	if ((this->CurrentMeanX == 0) && (this->CurrentMeanX2 == 0))
		return 0;
	else
		return this->CurrentMeanX2 - pow(this->CurrentMeanX, 2);
}

const double MeanVarianceDump::Mean() const {
	return this->CurrentMeanX;
}

void MeanVarianceDump::AddValue(const double &Value) {
	this->CurrentMeanX = ((this->CurrentMeanX * this->Total) + Value) / (this->Total + 1);
	this->CurrentMeanX2 = ((this->CurrentMeanX2 * this->Total) + pow(Value, 2)) / (this->Total + 1);
	(this->Total)++;
}
