/*
 * \author João V. Gomes
 *
 *  meanvariancedump.h
 *
 *  Created on: Nov 20, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef MEANVARIANCEDUMP_H_
#define MEANVARIANCEDUMP_H_

#include <math.h>

class MeanVarianceDump {
public:
	MeanVarianceDump();
	virtual ~MeanVarianceDump();
	const double Variance() const;
	const double Mean() const;
	void AddValue(const double &Value);

private:
	void init();
	void dispose();
	void Clear();

	double CurrentMeanX;
	double CurrentMeanX2;
	long Total;
};

#endif /* MEANVARIANCEDUMP_H_ */
