/*
 * \author João V. Gomes
 *
 *  thresholdsset.h
 *
 *  Created on: Jun 24, 2010
 *
 * \brief TODO
 * TODO
 */

#ifndef THRESHOLDSSET_H_
#define THRESHOLDSSET_H_

#include <map>
#include <string>
#include <iostream>

class ThresholdsSet {
public:
	ThresholdsSet();
	virtual ~ThresholdsSet();

	void AddThreshold(const double &MinValue, const std::string &Description);
	const std::string GetDescription(const double &Value);
	void Clear();
	void PrintThresholds();
private:
	std::map<double, std::string> Thresholds;

	void dispose();
};

#endif /* THRESHOLDSSET_H_ */
